

//	This source and file packaging method apply to GNU General Public License. 
//			Copyright (C) 2010,2014 and later Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			MLS file packager
//  		
//			written by Dzinleski Jasenko  2010 - March , 2016


#include 	<stdio.h>
#include 	<stdlib.h>
#include 	<string.h>
#include 	<math.h>
#include 	<errno.h>
#include 	<dirent.h>
#define		csl	28

FILE		*f1,*f2,*f3,*f4,*f5;

char		out1fn[256]="mls_o1.mar";
char		out2fn[256]="mls_o2.mar";
char		out3fn[256]="mls_o3.mar";
char		out4fn[256]="mls_o4.mar";

int		pf=0;
int		df=0;
int		of=1;

char		dirn[256];	int	dirni=0;
char		v_ext[256];	int	vexti=0;

char		c_l[256]="{[AZ][az]}{[::]}{[AZ][az][09][__][..][\\\\][**][////][::][--][  ][??][##]}";

int		b4o,b4e;
long		ba12[16][16][16][2];	int	ba12i=0;
long		da[16*16*16][2];
int 		dai;
char		p_s[256];
char		n_s[512];
char		rp_f[256];
char		rp_f_[256];
int 		rp_fi;
char 		sv[256];

struct		dirent 	*dentries;
	
char		r1[256]="FILENAME ";
char		r2[256]="SIZE ";
char		r3[256]="CHECKSUM STRING :";

char		outpath[256];
char		outdir[256];
char		outfilen[256];

//--------------------------------------------------------------
#ifdef _WINDOWS_

	#include 	<dir.h>
	#include 	<sys/stat.h>

	#define		os	1

	DIR			*dirl;	

	int	mkdir_(char dn[255])
	{
		int i;
		if(strlen(dn)==0){return(0);}
		for(i=0;i<strlen(dn);++i){if(dn[i]=='/'){dn[i]='\\';}}
		if(dn[-1+strlen(dn)]!='\\'){dn[strlen(dn)]='\\';}
		return(mkdir(dn));
	}

	int p_d_(char cmd[256],char lx[256])
	{

		int		i,j,k,l;
		int		fbyte;

		char		dn[256];
		char		fn[256];
		char		ll[256];
		char		st[256];
	
		char		cmd1[256]="dir/s/b "; 
		char		cmd2[256]=" > mls_o1.mar ";
		char		cmd3[256];
	
		for(i=0;i<256;++i){cmd3[i]='\0';}
		l=0;for(i=0;i<strlen(cmd1);++i){cmd3[l]=cmd1[i];++l;}
		for(i=0;i<strlen(cmd);++i){cmd3[l]=cmd[i];++l;}
		for(i=0;i<strlen(cmd2);++i){cmd3[l]=cmd2[i];++l;}
	
	if(system(NULL))
	{
	
		system(cmd3);
		printf("%s\n",lx);
		f1=fopen("mls_o1.mar","rb");
		f2=fopen("mls_o2.mar","w");
		fbyte=getc(f1);
		while(!feof(f1))
		{

			for(i=0;i<256;++i){ll[i]='\0';}
			l=0;while(fbyte!=13&&fbyte!=10){ll[l]=fbyte;++l;fbyte=getc(f1);}
			while(fbyte==13||fbyte==10){fbyte=getc(f1);}

			k=0;
			for(i=-1+strlen(lx);i>=0;--i)
			{
				if(lx[i]==ll[(-1+l)-k]){++k;if(k==strlen(lx)&&ll[(-1+l)-(k+1)]=='.'){break;}}else{break;}		
			}
			if(k==strlen(lx))
			{
				//printf("%s\n",ll);
				for(i=0;i<strlen(dn);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",dn[i]);}}
				for(i=0;i<strlen(ll);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",ll[i]);}}fprintf(f2,"%c%c",(char)13,(char)10);
			}
			
		}
		fclose(f1);
		fclose(f2);

	}else{return(0);}

	return(0);
	}

//--------------------------------------------------------------	
#else
//--------------------------------------------------------------
	#include 	<unistd.h>
	#include 	<wait.h>
	#ifndef 	__int64
	typedef long long __int64 ;
	#endif

	#define		os	2

	int p_1_(char *ar[],char ofn[256])
	{

		int 	i,j,k,l;
		int 	outf[2];
		int	status;

//printf("%s ",ar[0]);
//printf("%s ",ar[1]);
//printf("%s ",ar[2]);
//printf("%s ",ar[3]);
//printf("%s ",ar[4]);

		pipe(outf);
		pid_t pid=fork();
		if(pid==0)
		{
			//dup2(0,fileno(stdout));   //Console
			dup2(outf[1],fileno(stdout));
			if((status=execvp(ar[0],ar))<0){while(wait(&status)!= pid);}
		}

		if(pid==0){return(1);}else{

			close(outf[1]);
			dup2(outf[0],fileno(stdin));
	
			FILE *f=fdopen(outf[0],"rt");
			char buffer[32];
			FILE *o=fopen(ofn,"w");

			while(!feof(f)){fgets(buffer,32,f);fprintf(o,"%s",buffer);/*printf("%s",buffer);*/}
			fclose(o);

		}
		return(0);
	}

	int mkdir_(char cmd_2[256])
	{
	int i;
	char		cmd_1[256]="mkdir";
	//char		cmd_2[256]=" ";
	//char		cmd_3[256]=" ";
	//char		cmd_4[256]=" ";
	
	char		*cmd_[5];
	if(strlen(cmd_2)==0){return(0);}
	//printf("!%s!\n",cmd_2);
	for(i=0;i<strlen(cmd_2);++i){if(cmd_2[i]=='\\'){cmd_2[i]='/';}}
	if(cmd_2[-1+strlen(cmd_2)]!='/'){cmd_2[strlen(cmd_2)]='/';}

	cmd_[0]=cmd_1;
	cmd_[1]=cmd_2;
	cmd_[2]=NULL;
	cmd_[3]=NULL;
	cmd_[4]=NULL;

	return(p_1_(cmd_,"out.txt"));

	}

	int p_d_(char cmd__[256],char lx[256])
	{
	
	int		i,j,k,l;
	int		fbyte;

	char		dn[256];
	char		fn[256];
	char		ll[256];
	char		st[256];
		
	char		cmd_1[256]="ls";
	char		cmd_2[256]="--group-directories-first";
	char		cmd_3[256]="-1";
	char		cmd_4[256]="-R";

	char		*cmd_[6];
	static char 	*ar[]={"ls","--group-directories-first","-1","-R"};

	cmd_[0]=cmd_1;
	cmd_[1]=cmd_2;
	cmd_[2]=cmd_3;
	cmd_[3]=cmd_4;
	cmd_[4]=cmd__;
	cmd_[5]=NULL;

	//printf("%s %s\n",cmd__,lx);

	if(0!=p_1_(cmd_,"mls_o1.mar")){return(0);}
		
	FILE *f1=fopen("mls_o1.mar","rb");
	FILE *f2=fopen("mls_o2.mar","wb");
	for(j=0;j<256;++j){dn[j]='\0';}
	fbyte=getc(f1);
	while(!feof(f1))
	{

		for(i=0;i<256;++i){ll[i]='\0';}
		l=0;while(fbyte!=13&&fbyte!=10&&!feof(f1)){ll[l]=fbyte;++l;fbyte=getc(f1);}
		while(fbyte==13||fbyte==10&&!feof(f1)){fbyte=getc(f1);}

		if((ll[0]=='/')&&(ll[-1+l]==':'))
		{
			for(j=0;j<256;++j){dn[j]='\0';}
			j=0;for(i=0;i<(-1+l);++i){dn[j]=ll[i];++j;}
			dn[j]='/';++j;dn[j]='\0';
			//printf("%s\n",dn);
		}else{
			k=0;
			for(i=-1+strlen(lx);i>=0;--i)
			{
				if(lx[i]==ll[(-1+l)-k]){++k;if(k==strlen(lx)&&ll[(-1+l)-(k+1)]=='.'){break;}}else{break;}
			}
			if(k==strlen(lx))
			{
				//printf("%s\n",ll);
				for(i=0;i<strlen(dn);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",dn[i]);}}
				for(i=0;i<strlen(ll);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",ll[i]);}}
				fprintf(f2,"%c%c",(char)13,(char)10);
			}
		}
	}
	fclose(f1);
	fclose(f2);
	return(0);
	}

#endif
//--------------------------------------------------------------

double p_val(char arr0[256])
{

	int		sg=1;
	int		i,j=0,k=0,l;

	double		rv;
	__int64		rvf;
	__int64	rvd;

	if((arr0[0]=='-')||(arr0[0]=='+'))
	{
		if(arr0[0]=='-'){sg=-1;}
		l=0;for(j=1;j<strlen(arr0);++j){arr0[l]=arr0[j];++l;}
	}
	if(arr0[0]=='.')
	{
		l=strlen(arr0);for(j=strlen(arr0)-1;j>=0;--j){arr0[l]=arr0[j];--l;}
		arr0[l]='0';
	}
	for(j=0;j<strlen(arr0);++j){i=j;if(arr0[j]=='.'){break;}}
	if(j==strlen(arr0))
	{

		++i;
		rvd=0;l=-1;
		for(j=-1+i;j>=0;--j)
		{
			++l;rvd+=(__int64)(-48+arr0[j])*(__int64)pow(10,l);
		}
		
		rv=(double)rvd;
		
	}else{
	
		rvd=0;l=-1;
		for(j=-1+i;j>=0;--j)
		{
			++l;rvd+=(__int64)(-48+arr0[j])*(__int64)pow(10,l);
		}
		
		rvf=0;l=-1;
		for(j=-1+strlen(arr0);j>i;--j)
		{
			++l;rvf+=(__int64)(-48+arr0[j])*(__int64)pow(10,l);
		}
		
		rv=(double)rvd;
		rv+=(double)rvf/pow(10,-1+strlen(arr0)-i);
	
	}

	return((double)sg*rv);

}

double p_v(char pv_a1[256])
{

	int	df=0;
	int	i,l;
	double	p_v;

	p_v=0;l=0;
	for(i=-1+strlen(pv_a1);i>=0;--i)
	{
		p_v+=(double)(-48+(int)pv_a1[i])*pow(10,l);
		if(df){printf("%d %e\n",-48+(int)pv_a1[i],pow(10,l));}
		++l;
	}
	return(p_v);

}

long p_v_(char na[256])
{

__int64 	lv=0;
int			i,j,l;

for(i=0;i<strlen(na);++i){if(na[i]=='.'){break;}}
	
l=0;lv=0;
for(j=i-1;j>=0;--j){lv+=(na[j]-48)*pow(10,l);++l;}
	
return((long)lv);

}

int p_f__(long n)
{
	
int		p1=-1,p2=-1,p3=-1;
int		i,j,k,l;
char 	c1[256];

c1[0]='1';
c1[1]='2';
c1[2]='3';
c1[3]='4';
c1[4]='5';
c1[5]='6';
c1[6]='7';
c1[7]='8';
c1[8]='9';
c1[9]='0';

for(i=0;i<9;++i){
for(j=0;j<10;++j){
for(k=0;k<10;++k){
if(n/(((c1[i]-48)*100+(c1[j]-48)*10+(c1[k]-48)*1)*1000)==1){

if((double)n/(double)(((c1[i]-48)*100+(c1[j]-48)*10+(c1[k]-48)*1)*100)<=(double)10.01){

if((double)n/(double)(((c1[i]-48)*100+(c1[j]-48)*10+(c1[k]-48)*1)*10)<=(double)100.1){

p1=i;
p2=j;
p3=k;
}}}
}}}

if(p1!=-1&&p2!=-1&&p3!=-1)
{
rp_f[rp_fi]=c1[p1];++rp_fi;
rp_f[rp_fi]=c1[p2];++rp_fi;
rp_f[rp_fi]=c1[p3];++rp_fi;
//printf("!%c%c%c!\n",rp_f[rp_fi-3],rp_f[rp_fi-2],rp_f[rp_fi-1]);
}
return(0);

}

int p_f_(__int64 v)
{

int			i,j,k,l,m,ll;
long		n,q;
char		t_[256];
	
n=v;
for(i=0;i<256;++i){rp_f[i]='\0';}rp_fi=0;
l=1;m=-1;
while(l>0)
{
l=0;while(n>999.0){n/=10;++l;}
if(m==-1){m=l;ll=l;p_f__(n*pow(10,3));}else{
if(m-(l+3)>0){for(i=0;i<m-(l+3);++i){rp_f[rp_fi]='0';++rp_fi;}
p_f__(n*pow(10,3));}else{p_f__(n*pow(10,3));}m=l;}

if(strlen(rp_f)>ll+3){for(i=strlen(rp_f);i>=ll+3;++i){rp_f[i]='\0';rp_fi=strlen(rp_f);}}

if(n*pow(10,m)>v-p_v_(rp_f)*pow(10,l)){n=v-p_v_(rp_f)*pow(10,l);}

if(n<=99.0){break;}
}

if(n>0)
{

l=(ll+3)-strlen(rp_f);
for(i=0;i<ll+3;++i){if(rp_f[i]=='\0'){rp_f[i]='0';}/*printf("%c",rp_f[i]);*/}
//printf("\n");
for(i=ll+3;i<256;++i){rp_f[i]='\0';}
rp_fi=strlen(rp_f);
n=v-p_v_(rp_f);

if(n==0){}

if((n>0)&&(n<=9))
{

if(l>1)
{
--rp_fi;rp_f[rp_fi]='\0';
--rp_fi;rp_f[rp_fi]='\0';
}

if(l==1)
{
--rp_fi;rp_f[rp_fi]='\0';
}

if(n<999.0){while(n<999.0){n*=10;}n/=10;}
p_f__(n*pow(10,3));

if(l>1)
{
rp_f[rp_fi-2]=rp_f[rp_fi-3];
rp_f[rp_fi-3]='0';
--rp_fi;rp_f[rp_fi]='\0';
}

if(l==1)
{
--rp_fi;rp_f[rp_fi]='\0';
--rp_fi;rp_f[rp_fi]='\0';
}

if(v!=p_v_(rp_f)){printf("Error...\n");for(i=0;i<strlen(rp_f);++i){printf("%c",rp_f[i]);}printf("\n");}
//for(i=0;i<rp_fi;++i){printf("%c",rp_f[i]);}
//printf(".\n");
for(i=0;i<256;++i){t_[i]='\0';}
j=0;if(rp_f[j]=='0'){while(j<rp_fi&&rp_f[j]=='0'){++j;}}
k=0;for(i=j;i<rp_fi;++i){t_[k]=rp_f[i];++k;}
for(i=0;i<256;++i){rp_f[i]='\0';}
j=0;for(i=0;i<strlen(t_);++i){rp_f[j]=t_[i];++j;}rp_fi=j;
return(0);	

}

if((n>9)&&(n<=99))
{

if(l>1)
{
--rp_fi;rp_f[rp_fi]='\0';
--rp_fi;rp_f[rp_fi]='\0';
}

if(n<999.0){while(n<999.0){n*=10;}n/=10;}
p_f__(n*pow(10,3));

--rp_fi;rp_f[rp_fi]='\0';

if(v!=p_v_(rp_f)){printf("Error...\n");for(i=0;i<strlen(rp_f);++i){printf("%c",rp_f[i]);}printf("\n");}
//for(i=0;i<rp_fi;++i){printf("%c",rp_f[i]);}
//printf(".\n");
for(i=0;i<256;++i){t_[i]='\0';}
j=0;if(rp_f[j]=='0'){while(j<rp_fi&&rp_f[j]=='0'){++j;}}
k=0;for(i=j;i<rp_fi;++i){t_[k]=rp_f[i];++k;}
for(i=0;i<256;++i){rp_f[i]='\0';}
j=0;for(i=0;i<strlen(t_);++i){rp_f[j]=t_[i];++j;}rp_fi=j;
return(0);	

}

if((n>99)&&(n<=999))
{
	
--rp_fi;rp_f[rp_fi]='\0';
--rp_fi;rp_f[rp_fi]='\0';
--rp_fi;rp_f[rp_fi]='\0';

if(n<999.0){while(n<999.0){n*=10;}n/=10;}
p_f__(n*pow(10,3));
		
if(v!=p_v_(rp_f)){printf("Error...\n");for(i=0;i<strlen(rp_f);++i){printf("%c",rp_f[i]);}printf("\n");}
//for(i=0;i<rp_fi;++i){printf("%c",rp_f[i]);}
//printf(".\n");
for(i=0;i<256;++i){t_[i]='\0';}
j=0;if(rp_f[j]=='0'){while(j<rp_fi&&rp_f[j]=='0'){++j;}}
k=0;for(i=j;i<rp_fi;++i){t_[k]=rp_f[i];++k;}
for(i=0;i<256;++i){rp_f[i]='\0';}
j=0;for(i=0;i<strlen(t_);++i){rp_f[j]=t_[i];++j;}rp_fi=j;
return(0);	

}
}

if(n==0)
{
	
l=(ll+3)-strlen(rp_f);
for(i=0;i<ll+3;++i){if(rp_f[i]=='\0'){rp_f[i]='0';}/*printf("%c",rp_f[i]);*/}
//printf("\n");
for(i=ll+3;i<256;++i){rp_f[i]='\0';}
rp_fi=strlen(rp_f);
if(v!=p_v_(rp_f)){printf("Error...\n");for(i=0;i<strlen(rp_f);++i){printf("%c",rp_f[i]);}printf("\n");}
//for(i=0;i<rp_fi;++i){printf("%c",rp_f[i]);}
//printf(".\n");
for(i=0;i<256;++i){t_[i]='\0';}
j=0;if(rp_f[j]=='0'){while(j<rp_fi&&rp_f[j]=='0'){++j;}}
k=0;for(i=j;i<rp_fi;++i){t_[k]=rp_f[i];++k;}
for(i=0;i<256;++i){rp_f[i]='\0';}
j=0;for(i=0;i<strlen(t_);++i){rp_f[j]=t_[i];++j;}rp_fi=j;
return(0);	

}

return(0);

}

int p_format(double ar1,char fm[256],char ar2[256])
{

	int		i,j,k,l,m,n;
	int		sig=0;
	int		ar2i=-1+256;

	char		lfm[256]="0000000000";
	int		li=1;
	
	//0.00
	//#.00
	//#.##
	//000000
	//######
	//#,###,##0.00
	//
	
	if(ar1<0){ar1*=(double)-1;sig=1;}
	for(j=0;j<256;++j){ar2[j]='\0';}

	if(ar1==0){i=0;for(j=0;j<strlen(fm);++j){ar2[i]=fm[j];++i;}

		for(i=0;i<strlen(ar2);++i){if(ar2[i]=='#'){ar2[i]=' ';}}
		for(i=0;i<strlen(ar2);++i){if(ar2[i]==' '&&ar2[i+1]==','){ar2[i+1]=' ';}}
		return(0);
	}

	if(strlen(fm)!=0)
	{
		m=-1+strlen(fm);
		n=256-strlen(fm);

		for(i=-1+strlen(fm);i>=0;--i){if(fm[i]=='.'){break;}}//decimal point point
		if(i==-1)
		{

			p_f_(ar1);
			l=-1+strlen(rp_f);
			if(strlen(rp_f)==0){while(m>=0){ar2[ar2i]=fm[m];--ar2i;--m;}}else{
				while(l>=0){if(fm[m]==','){ar2[ar2i]=',';--ar2i;--m;}else{
					ar2[ar2i]=rp_f[l];--l;--ar2i;--m;}
				}
			}
			while(m>=0){ar2[ar2i]=fm[m];--ar2i;--m;}

		}else{
			
			p_f_(ar1);
			p_f_((ar1-p_v(rp_f))*pow(10,(-1+strlen(fm)-i)));
			k=-1+strlen(rp_f);
			l=-1+strlen(fm)-i;i=0;while(k>=0||l>i){if(k>=0){ar2[ar2i]=rp_f[k];--k;--ar2i;--l;}else{
				ar2[ar2i]='0';--ar2i;--l;}}ar2[ar2i]='.';--ar2i;m=1;

			p_f_(ar1);
			l=-1+strlen(rp_f);
			if(strlen(rp_f)==0){while(m>=0){ar2[ar2i]='0';--ar2i;--m;}}else{
				while(l>=0){ar2[ar2i]=rp_f[l];--l;--ar2i;}
			}

		}
	
	}else{

		p_f_(ar1);
		p_f_((ar1-p_v(rp_f))*pow(10,2));
		k=-1+strlen(rp_f);
		l=2;i=0;while(k>=0||l>i){if(k>=0){ar2[ar2i]=rp_f[k];--k;--ar2i;--l;}else{
			ar2[ar2i]='0';--ar2i;--l;}}ar2[ar2i]='.';--ar2i;m=1;

		p_f_(ar1);
		l=-1+strlen(rp_f);
		if(strlen(rp_f)==0){while(m>=0){ar2[ar2i]='0';--ar2i;--m;}}else{
			while(l>=0){ar2[ar2i]=rp_f[l];--l;--ar2i;}
		}

	}

	l=0;if(sig==1){ar2[l]='-';++l;for(i=1;i<256;++i){if(ar2[i]!='\0'){ar2[l]=ar2[i];++l;}}}else{
		for(i=0;i<256;++i){if(ar2[i]!='\0'){ar2[l]=ar2[i];++l;}}
	}
	for(i=l;i<256;++i){ar2[i]='\0';}

	for(i=0;i<strlen(ar2);++i){if(ar2[i]=='#'){ar2[i]=' ';}}
	for(i=0;i<strlen(ar2);++i){if(ar2[i]==' '&&ar2[i+1]==','){ar2[i+1]=' ';}}

	return(0);

}

int	c_p(char cl_a[256],int ci,int tf,char r_a[256])
{

	int		a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}

	if(tf)
	{
		for(a=0;a<strlen(c_l);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;/*printf("%c",cl_a[c]);*/}

	return(0);

}

long p_cs(char infn[256])
{

	int		i,j,k,l,m,n,p,q;
	int		a,b,c,d;
	int 	d1,d2,d3;
	int		nH,nL;
	long	bc=0;

	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){
		ba12[i][j][k][0]=-1;ba12[i][j][k][1]=0;
	}}}ba12i=0;
	for(i=0;i<16*16*16;++i){da[i][0]=-1;da[i][1]=0;}dai=0;

	f1=fopen(infn,"rb");
	nH=getc(f1);if(!feof(f1)){++bc;}else{return(bc);}
	nL=getc(f1);if(!feof(f1)){++bc;}else{return(bc);}
	while(!feof(f1))
	{
		n=(nH<<8)|nL;
		a=((n&0xf000)>>12)&0xf;b=((n&0x0f00)>>8)&0xf;
		d1=(((b4e&a)^(b4o&b)<<1)|((b4e&b)^(b4o&a)<<1));
		a=((n&0x0f00)>>8)&0xf;b=((n&0x00f0)>>4)&0xf;
		d2=(((b4e&a)^(b4o&b)<<1)|((b4e&b)^(b4o&a)<<1));
		a=((n&0x00f0)>>4)&0xf;b=((n&0x000f)>>0)&0xf;
		d3=(((b4e&a)^(b4o&b)<<1)|((b4e&b)^(b4o&a)<<1));

		if(ba12[d1][d2][d3][0]==-1){ba12[d1][d2][d3][0]=ba12i;++ba12i;ba12[d1][d2][d3][1]=1;}else{
			++ba12[d1][d2][d3][1];
		}
		nH=nL;nL=getc(f1);if(!feof(f1)){++bc;}else{break;}
	}
	fclose(f1);

	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){
		if(ba12[i][j][k][0]!=-1)
		{
			da[dai][0]=ba12[i][j][k][0];da[dai][1]=ba12[i][j][k][1];++dai;
		}
	}}}		
	return(bc);	
}

int	p_21()
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	int	fbyte,fbyte_,sfc=0;

	long bc=0;

	//printf("!%s!%s!\n",dirn,v_ext);	
	p_d_(dirn,v_ext);

	f2=fopen(out2fn,"rb");
	f3=fopen(out3fn,"w");
	f4=fopen(out4fn,"wb");

	fbyte=getc(f2);
	while (!feof(f2))
	{

		for(i=0;i<256;++i){dirn[i]='\0';}
		j=0;while(!feof(f2)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f2);}
		while(!feof(f2)&&(fbyte==13||fbyte==10)){fbyte=getc(f2);}

		//printf("%s\n",dirn);
		if(strlen(dirn)==0){break;}

		//stat(dirn,&fp);
		f5=fopen(dirn,"rb");if(f5==NULL){continue;}else{
			if(feof(f5)){fclose(f5);continue;}else{
				if(getc(f5)==-1){fclose(f5);continue;}else{
					fclose(f5);
					bc=p_cs(dirn);
				}
			}
		}
		
		for(i=0;i<256;++i){p_s[i]='\0';}p_format((double)bc,"0000000000",p_s);

		if(bc==0){continue;}

		//printf("FILENAME %s\nSIZE %s\n",dirn,p_s);
		fprintf(f3,"FILENAME %s\nSIZE %s\n",dirn,p_s);
		//printf("CHECKSUM STRING :\n");
		fprintf(f3,"CHECKSUM STRING :\n");
		j=0;for(i=0;i<512;++i){n_s[i]='\0';}
		for(a=0;a<dai;++a)
		{
				for(i=0;i<256;++i){p_s[i]='\0';}p_format((double)da[a][0],"0000",p_s);		
				for(i=0;i<strlen(p_s);++i){fprintf(f3,"%c",p_s[i]);/*printf("%c",p_s[i]);*/}
				for(i=0;i<256;++i){p_s[i]='\0';}p_format((double)da[a][1],"0000000000",p_s);	
				for(i=0;i<strlen(p_s);++i){fprintf(f3,"%c",p_s[i]);/*printf("%c",p_s[i]);*/}
				fprintf(f3,"%c%c",(char)13,(char)10);
		}
		f1=fopen(dirn,"rb");
		m=getc(f1);while(!feof(f1)){if(!feof(f1)){fprintf(f4,"%c",m);}else{break;}m=getc(f1);}
		fclose(f1);
		printf("Added %s\n",dirn);
	}
	fclose(f2);
	fclose(f3);
	fclose(f4);

	return(0);

}

int p_3(char dirn_[256])
{
	int i;
	if(strlen(dirn_)==0){return(0);}
	if(os==1)
	{
		for(i=0;i<strlen(dirn_);++i){if(dirn_[i]=='/'){dirn_[i]='\\';}}
		if(dirn_[-1+strlen(dirn_)]!='\\'){dirn_[strlen(dirn_)]='\\';}
	}else{
		for(i=0;i<strlen(dirn_);++i){if(dirn_[i]=='\\'){dirn_[i]='/';}}
		if(dirn_[-1+strlen(dirn_)]!='/'){dirn_[strlen(dirn_)]='/';}
	}
	mkdir_(dirn_);
	return(0);
}

int	p_22()
{

	int		a,b,c,ci,d;
	int		i,j,k,l,m;
	int		fbyte,fbyte_;
	char	dn[256];
	long	sfc=0,n;

	f4=fopen(out4fn,"rb");
	f3=fopen(out3fn,"rb");

	fbyte=getc(f3);
	while (!feof(f3))
	{

		for(i=0;i<256;++i){dirn[i]='\0';}
		j=0;while(!feof(f3)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f3);}
		while(!feof(f3)&&(fbyte==13||fbyte==10)){fbyte=getc(f3);}
		
		if(strlen(dirn)==0){continue;}

		for(i=0;i<strlen(r1);++i){if(r1[i]!=dirn[i]){break;}}
		if(i==strlen(r1))
		{

			//printf("%s\n",dirn);

			if(os==1)
			{
				for(i=-1+strlen(dirn);i>=1+strlen(r1);--i){if(dirn[i]=='\\'){j=i;break;}}
				for(i=0;i<256;++i){outdir[i]='\0';}
				m=0;for(i=strlen(r1);i<j;++i){if(dirn[1+i]==':'){++i;}else{outdir[m]=dirn[i];++m;}}
				for(i=0;i<256;++i){outfilen[i]='\0';}
				m=0;for(i=0;i<strlen(outpath);++i){outfilen[m]=outpath[i];++m;}
				if(outfilen[-1+strlen(outfilen)]!='\\'){outfilen[strlen(outfilen)]='\\';}
				for(i=strlen(r1);i<strlen(dirn);++i){if(dirn[1+i]==':'){++i;}else{outfilen[m]=dirn[i];++m;}}
			}else{
				for(i=-1+strlen(dirn);i>=1+strlen(r1);--i){if(dirn[i]=='/'){j=i;break;}}
				for(i=0;i<256;++i){outdir[i]='\0';}
				m=0;for(i=strlen(r1);i<j;++i){outdir[m]=dirn[i];++m;}
				for(i=0;i<256;++i){outfilen[i]='\0';}
				m=0;for(i=0;i<strlen(outpath);++i){outfilen[m]=outpath[i];++m;}
				if(outfilen[-1+strlen(outfilen)]!='/'){outfilen[strlen(outfilen)]='/';}
				for(i=strlen(r1);i<strlen(dirn);++i){outfilen[m]=dirn[i];++m;}
			}

			if(pf){printf("outpath %s\n",outfilen);}
			if(pf){printf("outpath %s\n",outpath);}

			if(chdir(outpath)==-1){p_3(outpath);chdir(outpath);}

			if(pf){printf("outdir %s\n",outdir);}

			if(os==1)
			{
				i=0;j=0;while(i<strlen(outdir))
				{
					for(m=0;m<256;++m){dn[m]='\0';}
					m=0;j=i+1;while(j<strlen(outdir)&&outdir[j]!='\\'){dn[m]=outdir[j];++m;++j;}if(pf){printf("%s\n",dn);}i=j;
					if(chdir(dn)==-1){p_3(dn);chdir(dn);}
				}
			}else{
				i=0;j=0;while(i<strlen(outdir))
				{
					for(m=0;m<256;++m){dn[m]='\0';}
					m=0;j=i+1;while(j<strlen(outdir)&&outdir[j]!='/'){dn[m]=outdir[j];++m;++j;}if(pf){printf("%s\n",dn);}i=j;
					if(chdir(dn)==-1){p_3(dn);chdir(dn);}
				}
			}
			continue;
		}

		for(i=0;i<strlen(r2);++i){if(r2[i]!=dirn[i]){break;}}
		if(i==strlen(r2))
		{
			for(k=0;k<256;++k){p_s[k]='\0';}
			l=0;for(j=i+1;j<strlen(dirn);++j){p_s[l]=dirn[j];++l;}
			n=(int)p_val(p_s);

			if(pf){printf("?%s\n",outfilen);}

			f5=fopen(outfilen,"wb");
			fbyte_=getc(f4);fprintf(f5,"%c",fbyte_);++sfc;
			while(!feof(f4)&&sfc<n){fbyte_=getc(f4);fprintf(f5,"%c",fbyte_);++sfc;}fclose(f5);sfc=0;
			continue;
		}

		for(i=0;i<strlen(r3);++i){if(r3[i]!=dirn[i]){break;}}
		if(i==strlen(r3))
		{
			p_cs(outfilen);
			for(a=0;a<dai;++a)
			{
					j=0;for(i=0;i<512;++i){n_s[i]='\0';}
					for(i=0;i<256;++i){p_s[i]='\0';}p_format((double)da[a][0],"0000",p_s);		
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					for(i=0;i<256;++i){p_s[i]='\0';}p_format((double)da[a][1],"0000000000",p_s);	
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					for(i=0;i<256;++i){dirn[i]='\0';}
					j=0;while(!feof(f3)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f3);}
					while(!feof(f3)&&(fbyte==13||fbyte==10)){fbyte=getc(f3);}

					if(strlen(dirn)!=0&&strlen(n_s)!=0)
					{
						if(strlen(dirn)==strlen(n_s))
						{
							l=0;for(k=0;k<strlen(n_s);++k)
							{if(dirn[k]!=n_s[k]){break;}else{++l;}}
							if(l!=strlen(n_s)){
printf("File: %s\n2.CHECKSUM Error...!%s! !%s! !%d!\n",outpath,dirn,n_s,l);return(0);}else{/*printf("%02d",a);*/}
						}else{
printf("File: %s\n1.CHECKSUM Error...!%s! !%s! !%d %d!\n",outpath,dirn,n_s,strlen(dirn),strlen(n_s));return(0);}
					}
			}
			printf("Restored %s Ok\n",outfilen);

			continue;
		}

	}
	fclose(f3);

	return(0);

}

int main(int argc,char *argv[])
{


	char	cmd[50][256];

	char	c_1[256];
	char	c_2[256];
	char	c_3[256];
	char	c_4[256];
	char	c_5[256];
	char	c_6[256];

	char	c_1_[20][256];
	char	f_1_[20][256];

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	int	fbyte,fbyte_,sfc=0;

	b4o=0;
	b4o|=1<<0;
	b4o|=1<<2;

	b4e=0;
	b4e|=1<<1;
	b4e|=1<<3;

	//
	printf("\nMLS File packager \nwritten by Dzinleski Jasenko 2010 , March 2016\n");
	printf("\n");
	printf("\nOS Win32 VRM 2.0.0\n\n");
	//


	if((argv[1]!=NULL)&&((argv[1][0]=='-'&&argv[1][1]=='e')||(argv[1][0]=='-'&&argv[1][1]=='l')))
	{
			printf("\n\n");
			printf("\nMLS file packager written by Dzinleski Jasenko 2010 , March 2016\n");
			printf("\n");
			printf("\nOS Win32 VRM 2.0.0\n\n");
			printf("\n");
			printf("\tThis source and file packager method apply to GNU General Public License.\n");
			printf("\t		Copyright (C) 2010 and later Jasenko Dzinleski \n");
			printf("\n");
			printf("\t	This program is free software; you can redistribute it\n");
			printf("\tand/or modify it under the terms of the GNU General Public License as\n");
			printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
			printf("\tLicense, or (at your option) any later version.\n");
			printf("\n");
			printf("\tThis program is distributed in the hope that it will be useful, but\n");
			printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
			printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
			printf("\tGeneral Public License for more details.\n");
			printf("\n");
			printf("\tYou should have received a copy of the GNU General Public License along\n");
			printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
			printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
			printf("\n");

			return(0);

	}

	if((argv[1]!=NULL)&&(argv[1][0]=='-'&&argv[1][1]=='h'))
	{

			printf("\nMLS File packager \nwritten by Dzinleski Jasenko 2010,2014\n");
			printf("\n");
			printf("\nOS Win32 VRM 2.0.0\n\n");
			printf("To create : mls_1 {[-c]|[-r]|[-e]|[-l]|[-h]} <Source Path> {[drive:][\\path...\\]} [*|*.[ext]] \nTo restore : mls_1 {[-c]|[-r]|[-e]|[-l]|[-h]} <Ouput Path> {[drive:][\\path...\\]} \n");
			printf("mls_a01-04 .mar file(s) will be created in the current path\n");
			printf("\n");

			return(0);
	}

	if(argv[1]==NULL||argv[2]==NULL){return(0);}else{

		if((argv[1][0]=='-'&&argv[1][1]=='c')||(argv[1][0]=='-'&&argv[1][1]=='r')){}else{printf("Command sw. Error...\n");return(0);}
	}

	for(j=0;j<256;++j){dirn[j]='\0';}
	for(j=0;j<256;++j){v_ext[j]='\0';}
	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}


	//------------

	ci=1;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,1,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_6[i]='\0';}
	c_p(c_1,ci,0,c_6);
	//for(i=0;i<strlen(c_6);++i){printf("%c",c_6[i]);}


	ci=2;
	for(i=0;i<256;++i){c_5[i]='\0';}
	c_p(c_1,ci,0,c_5);
	//for(i=0;i<strlen(c_5);++i){printf("%c",c_5[i]);}


	ci=2;
	for(i=0;i<256;++i){c_3[i]='\0';}
	c_p(c_l,ci,1,c_3);
	//for(i=0;i<strlen(c_3);++i){printf("%c",c_3[i]);}

	ci=1;
	for(i=0;i<256;++i){c_4[i]='\0';}
	c_p(c_3,ci,0,c_4);
	//for(i=0;i<strlen(c_4);++i){printf("%c",c_4[i]);}

	if(argv[1][0]=='-'&&argv[1][1]=='c')
	{

	if(os==1)
	{

	//Input Drive Spec.
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i)
	{
		if
		(
			(cmd[2][i]>=c_6[0]&&cmd[2][i]<=c_6[1])||
			(cmd[2][i]>=c_5[0]&&cmd[2][i]<=c_5[1])

		){dirn[dirni]=cmd[2][i];++dirni;}else{break;}
	}
	if(cmd[2][i]==c_4[0]){}else{printf("Input Drive Spec. Error...\n");return(0);}
	dirn[dirni]=':';++dirni;

	}

	}

	if(argv[1][0]=='-'&&argv[1][1]=='r')
	{

	if(os==1)
	{

	//Output Drive Spec.
	l=0;
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i)
	{
		if
		(
			(cmd[2][i]>=c_6[0]&&cmd[2][i]<=c_6[1])||
			(cmd[2][i]>=c_5[0]&&cmd[2][i]<=c_5[1])

		){outpath[l]=cmd[2][i];++l;}else{break;}
	}
	if(cmd[2][i]==c_4[0]){}else{printf("Output Drive Spec. Error...\n");return(0);}
	outpath[l]=':';++l;

	}

	}
	//------------


	ci=3;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,1,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}


	ci=1;
	for(i=0;i<256;++i){c_1_[1][i]='\0';}
	c_p(c_1,ci,0,c_1_[1]);
	ci=2;
	for(i=0;i<256;++i){c_1_[2][i]='\0';}
	c_p(c_1,ci,0,c_1_[2]);
	ci=3;
	for(i=0;i<256;++i){c_1_[3][i]='\0';}
	c_p(c_1,ci,0,c_1_[3]);
	ci=4;
	for(i=0;i<256;++i){c_1_[4][i]='\0';}
	c_p(c_1,ci,0,c_1_[4]);
	ci=5;
	for(i=0;i<256;++i){c_1_[5][i]='\0';}
	c_p(c_1,ci,0,c_1_[5]);
	ci=6;
	for(i=0;i<256;++i){c_1_[6][i]='\0';}
	c_p(c_1,ci,0,c_1_[6]);
	ci=7;
	for(i=0;i<256;++i){c_1_[7][i]='\0';}
	c_p(c_1,ci,0,c_1_[7]);
	ci=8;
	for(i=0;i<256;++i){c_1_[8][i]='\0';}
	c_p(c_1,ci,0,c_1_[8]);
	ci=9;
	for(i=0;i<256;++i){c_1_[9][i]='\0';}
	c_p(c_1,ci,0,c_1_[9]);
	ci=10;
	for(i=0;i<256;++i){c_1_[10][i]='\0';}
	c_p(c_1,ci,0,c_1_[10]);
	ci=11;
	for(i=0;i<256;++i){c_1_[11][i]='\0';}
	c_p(c_1,ci,0,c_1_[11]);
	ci=12;
	for(i=0;i<256;++i){c_1_[12][i]='\0';}
	c_p(c_1,ci,0,c_1_[12]);
	ci=13;
	for(i=0;i<256;++i){c_1_[13][i]='\0';}
	c_p(c_1,ci,0,c_1_[13]);


	if(argv[1][0]=='-'&&argv[1][1]=='c')
	{

	//Input Spec.
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i){}if(i==strlen(cmd[2])){i=-1;}

	for(j=i+1;j<strlen(cmd[2]);++j)
	{
		if
		(
			(cmd[2][j]>=c_1_[1][0]&&cmd[2][j]<=c_1_[1][1])||
			(cmd[2][j]>=c_1_[2][0]&&cmd[2][j]<=c_1_[2][1])||
			(cmd[2][j]>=c_1_[3][0]&&cmd[2][j]<=c_1_[3][1])||
			(cmd[2][j]>=c_1_[4][0]&&cmd[2][j]<=c_1_[4][1])||
			(cmd[2][j]>=c_1_[5][0]&&cmd[2][j]<=c_1_[5][1])||
			(cmd[2][j]>=c_1_[6][0]&&cmd[2][j]<=c_1_[6][1])||
			(cmd[2][j]>=c_1_[8][0]&&cmd[2][j]<=c_1_[8][1])||
			(cmd[2][j]>=c_1_[10][0]&&cmd[2][j]<=c_1_[10][1])||
			(cmd[2][j]>=c_1_[11][0]&&cmd[2][j]<=c_1_[11][1])

		){if(cmd[2][j]!='\''&&cmd[2][j]!='"'){dirn[dirni]=cmd[2][j];++dirni;}}else{break;}
	}
	if(j==strlen(cmd[2])){}else{

		for(i=-1+strlen(cmd[2]);i>=0;--i){if(cmd[2][i]=='.'){j=i;break;}}
		
		//for(i=j;i<strlen(cmd[2]);++i)
		for(i=j+1;i<strlen(cmd[2]);++i)
		{
			if
			(
				(cmd[2][i]>=c_1_[1][0]&&cmd[2][i]<=c_1_[1][1])||
				(cmd[2][i]>=c_1_[2][0]&&cmd[2][i]<=c_1_[2][1])||
				(cmd[2][i]>=c_1_[3][0]&&cmd[2][i]<=c_1_[3][1])||
				(cmd[2][i]>=c_1_[4][0]&&cmd[2][i]<=c_1_[4][1])||
				(cmd[2][i]>=c_1_[5][0]&&cmd[2][i]<=c_1_[5][1])||
				(cmd[2][i]>=c_1_[6][0]&&cmd[2][i]<=c_1_[6][1])||
				(cmd[2][i]>=c_1_[7][0]&&cmd[2][i]<=c_1_[7][1])||
				(cmd[2][i]>=c_1_[10][0]&&cmd[2][i]<=c_1_[10][1])
		
			)
			{

				if
				(
				(cmd[2][i]>=c_1_[1][0]&&cmd[2][i]<=c_1_[1][1])||
				(cmd[2][i]>=c_1_[2][0]&&cmd[2][i]<=c_1_[2][1])||
				(cmd[2][i]>=c_1_[3][0]&&cmd[2][i]<=c_1_[3][1])||
				(cmd[2][i]>=c_1_[4][0]&&cmd[2][i]<=c_1_[4][1])||
				(cmd[2][i]>=c_1_[5][0]&&cmd[2][i]<=c_1_[5][1])||
				(cmd[2][i]>=c_1_[7][0]&&cmd[2][i]<=c_1_[7][1])||
				(cmd[2][i]>=c_1_[10][0]&&cmd[2][i]<=c_1_[10][1])

				){v_ext[vexti]=cmd[2][i];++vexti;}
			
			}else{break;}
		}
		if(i==strlen(cmd[2])){}else{printf("Input Path Spec. Error...\n");return(0);}

	}

	}

	
	if(argv[1][0]=='-'&&argv[1][1]=='r')
	{

	//Output Spec.
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i){}if(i==strlen(cmd[2])){i=-1;}

	
	for(j=i+1;j<strlen(cmd[2]);++j)
	{
		if
		(
			(cmd[2][j]>=c_1_[1][0]&&cmd[2][j]<=c_1_[1][1])||
			(cmd[2][j]>=c_1_[2][0]&&cmd[2][j]<=c_1_[2][1])||
			(cmd[2][j]>=c_1_[3][0]&&cmd[2][j]<=c_1_[3][1])||
			(cmd[2][j]>=c_1_[4][0]&&cmd[2][j]<=c_1_[4][1])||
			(cmd[2][j]>=c_1_[5][0]&&cmd[2][j]<=c_1_[5][1])||
			(cmd[2][j]>=c_1_[6][0]&&cmd[2][j]<=c_1_[6][1])||
			(cmd[2][j]>=c_1_[8][0]&&cmd[2][j]<=c_1_[8][1])||
			(cmd[2][j]>=c_1_[10][0]&&cmd[2][j]<=c_1_[10][1])||
			(cmd[2][j]>=c_1_[11][0]&&cmd[2][j]<=c_1_[11][1])


		){outpath[l]=cmd[2][j];++l;}else{break;}
	}
	if(j==strlen(cmd[2])){}else{printf("Output Path Spec. Error...\n");return(0);}

	}

	if(argv[1][0]=='-'&&argv[1][1]=='c')
	{
		p_21();
	}
	if(argv[1][0]=='-'&&argv[1][1]=='r')
	{

		for(i=0;i<10;++i){for(j=0;j<256;++j){f_1_[i][j]='\0';}}
		strcpy(f_1_[0],out1fn);
		strcpy(f_1_[1],out2fn);
		strcpy(f_1_[2],out3fn);
		strcpy(f_1_[3],out4fn);

		p_22();

		//remove("mls_o1.mar");
		//remove("mls_o2.mar");
		//remove("mls_o3.mar");
		//remove("mls_o4.mar");

	}

	return(0);

}
